;LinkTest.asm
; Sets Port 7 to certain values,
;  reads back and displays results.
;
; Unlimited use granted.
;
; By Joe Clussman
; 1 July 2002
;
#include "ti86asm.inc"

.org _asm_exec_ram

    nop
    jp ProgStart
    .dw 0
    .dw ShellTitle

ShellTitle:
    .db "Internal Link Test   press 2nd",0

ProgStart:
    call _flushallmenus
    call _newline
    ld HL,ShellTitle
    call _puts
    call _newline
    
    ld HL,Text1
    call _puts
    ld A,$FC
    out (7),A
    call StatsNWait
    
    ld HL,Text2
    call _puts
    ld A,$E8
    out (7),A
    call StatsNWait
    
    ld HL,Text3
    call _puts
    ld A,$D4
    out (7),A
    call StatsNWait
    
    ld HL,Text4
    call _puts
    ld A,$C0
    out (7),A
    call StatsNWait
    

    ld A,$C0                ;end of program
    out (7),A    
    ld HL,TextHitAKey
    call _puts
    call _getkey
    
    ret


StatsNWait:
    call _newline
    ld HL,TextStatus
    call _puts
    in A,(7)
    ld L,A
    xor A
    ld H,A
    call _dispAHL


SNWLP1:
    halt                   ;don't wanna go full speed here in this loop
    ld a,%00111111         ;key mask for row 6 (More Exit 2nd F1-F5)
    out (1),a              ;key port
    nop
    nop
    in a,(1)               ;read key status
    cp 255                 ;check for any of those keys being zero
    
    jr Z,SNWLP1           ;loop until a key is pressed

SNWLP2:   
    halt                   ;switch bounce...
    ld a,%00111111         ;key mask for row 6 (More Exit 2nd F1-F5)
    out (1),a              ;key port
    nop
    nop
    in a,(1)               ;read key status
    cp 255                 ;check for any of those keys being zero
    
    jr NZ,SNWLP2           ;loop until no key is pressed    
    
;    call _getkey  --seems to check, amoung other things, the link port status.
;                     screws things up in the process, which is a no-no.
    call _newline
    ret


Text1:
.db "Writing $FC",0
Text2:
.db "Writing $E8",0
Text3:
.db "Writing $D4",0
Text4:
.db "Writing $C0",0 


TextStatus:
.db "Status: ",0

TextHitAKey:
.db "Hit A Key...",0


.end
