;LinkTxRx.asm
; Receives and displays anything incoming from link port.
; Press F1 or F2 to send a "1" or a "2"
; EXIT should always get you out of program.
;
; By Joe Clussman
; 1 July 2002
;
#include "ti86asm.inc"

.org _asm_exec_ram

    nop
    jp ProgStart
    .dw 0
    .dw ShellTitle

ShellTitle:
    .db "Xmit and Rcv Chars",0

ProgStart:
    call _runindicoff
    call _flushallmenus
    call _clrLCD
    call _homeup

    ld HL,ShellTitle
    call _puts
    call _newline
    
    ld A,'>'            ;prompt
    call _putc
mainloop:
    ld a,%00111111         ;key mask for row 6 (More Exit 2nd F1-F5)
    out (1),a              ;
    nop
    nop
    in a,(1)               ;read key status
    bit 6,a                ;check for EXIT key
    jr Z,DoneExit
    bit 4,a
    jr Z,DoF1
    bit 3,a
    jr Z,DoF2
    
    ld D,200                 ;200 tries for each bit...
    call ReceiveByte        ;byte in A
    jr C,Timeout
    
    ld L,A                  ;show the byte received in decimal format.
    xor A
    ld H,A
    call _dispAHL
    jr mainloop
    

Timeout:
    halt
    halt
    jr mainloop

DoF1:
    ld A,'1'
    call SendByte
    jr NC,mainloop
    jr Timeout
    
DoF2:
    ld A,'2'
    call SendByte
    jr NC,mainloop
    jr Timeout

DoneExit:
    call _clrScrn
    ret

#include "link2.asm"


.end
